#######################################################################################
# Suzi Project script
#              :
# : suzi@ircworld.ru
# : http://xirc.ru/plugins/forum/forum_viewforum.php?15
# -
#  : http://www.IRCWorld.ru & http://www.xIRC.ru
#######################################################################################

package require Tcl 	8.4
package require http	2

namespace eval weather {

# ---------------------------------------------------------------------------
#  
# ---------------------------------------------------------------------------
	#    , ,   

	variable author			"Suzi <Suzi@ircworld.ru>"
	variable version		"01.01"
	variable date			"24-MAY-2006"

	#     
	variable unamespace		[string range [namespace current] 2 end]

	#     (   )
	variable pubprefix 		{!}
	variable pubflag			{-|-}

	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:weather		"$unamespace  "

	#    ,   
	variable msgprefix		{!}
	variable msgflag			{-|-}
	#       ,      
	# ( --  )
	variable msg:weather		${pub:weather}

	#     
	variable dccprefix		{}
	variable dccflag			{n|-}
	variable dcc:widpudate "cityidupdate ciupd"

	#      ,      
	#     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id 
	#  .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	1

	#     
	variable maxrequests	10

	#   ,       , 
	#  
	variable pause			30
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -
	#  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		""
	
	#   ,   /   
	#          
	#          -- "nodream"
	#      

	variable chflag			"$flagactas$unamespace"

	setudef  flag 			$chflag

# ---------------------------------------------------------------------------
#    
# ---------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$opt $ustr'}
	
	#     ,   -- 
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   -- 
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :$unick, }

	#      
	variable maxredir		1
	
	#    ,   20 
	variable timeout		60000

	#    
	variable err_ok			{}

	#     ,     
	#       
	variable err_fail		{     .  .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
# ---------------------------------------------------------------------------
#  ,    
# ---------------------------------------------------------------------------
	# ,     
	variable 		fetchurl		"http://pda.gismeteo.ru"

	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 

	variable 		cityid
	array unset	cityid 

	variable		updinprogress	0

	variable		updatetimeout	60000

	variable		cidbasename		"$unamespace.dbi"

#
	proc msg:weather { unick uhost handle str } {
		pub:weather $unick $uhost $handle $unick $str
		return
	}

	proc pub:weather { unick uhost handle uchan str } {
#		putlog "dream"

		variable requserid
		variable fetchurl
		variable chflag
		variable flagactas
		variable errsend
		variable cityid		
		variable pubprefix
		variable unamespace

		set id 	 [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]

		if { $unick ne $uchan } {
			if { ![channel get $uchan $chflag] ^ $flagactas eq "no" } {
				return
			}
		}

		set why  [queue_isfreefor $id]
		
		if { $why != "" } {
			lput puthelp $why $prefix
			return
		}

		set ustr [string tolower $str]

		set opts [lrange [split $ustr] 0 2]
		
		set opt  [string trim [lindex $opts 0]]
		
		if { $opt eq "-" } {
			set ustr [string trim [lindex $opts 1]]
		} else {
			set ustr $opt
			set opt {}
		}

		regsub -all -nocase {[^\w.-]} $ustr {} ustr

		if { $ustr eq "" } {			
			lput puthelp " . : '$pubprefix$unamespace \[-\] '." $prefix
			return;
		}

		set cid [list]

		while {1} {
			# try first exact mathcing
			set cid [array names cityid -exact $ustr]
			if { [llength $cid] == 1 } {
				break
			}

			# try more wide mask
			set cid [array names cityid -glob "*$ustr*"]			
			break
		}

		if { [llength $cid] == 0 } {
			lput puthelp ",  '$ustr'    ." $prefix
			return
		}

		if { [llength $cid] > 1 } {
			set cilist [join [lrange $cid 0 15] {, }]
			if { [llength $cid] > 16 } {
				set ellips ", ..."
			} else {
				set ellips ""				
			}
			lput puthelp " ,    ($cilist$ellips)" $prefix
			return
		}

		set ustr $cid

		set cidx $cityid($ustr)

#		putlog "$ustr $cidx"

		variable logrequests

		if { $logrequests ne "" } {
			set logstr [subst -nocommands $logrequests]
			variable unamespace
			lput putlog $logstr "$unamespace: "
		}

#		::http::config -urlencoding cp1251
#		set query [::http::formatQuery key $ustr]

		variable fetchurl		

		if { [queue_add "$fetchurl/e$cidx.htm" $id "[namespace current]::dream:parser" [list $unick $uhost $opt $uchan {}]] } {
			variable err_ok
			if { $err_ok ne "" } {
				lput puthelp "$err_ok.  '$ustr'" $prefix
			}
		} else {
			variable err_fail
			if { $err_fail ne "" } {
				lput puthelp $err_fail $prefix
			}
		}

		return
	}

	proc dream:parser { errid errstr body extra } {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_fail

		variable pubsend
		variable msgsend
		variable errsend

		foreach { unick uhost handle uchan ustr } $lextra { break }

		if { $lerrid ne {ok} } {
			lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]
			return
		}

		if { $uchan eq $unick } {
			set prefix [subst -nocommands $msgsend]
		} else {
			set prefix [subst -nocommands $pubsend]
		}

		set str [encoding convertfrom cp1251 $lbody]

		set fsuccess 0
		set rxs1 {<center>(.+?)</center>}
		set rxs2 {<center>(.+?)</center>.+?<img.+?(\d)\.gif\">.+?<td.+?>&nbsp;(.+?)</td>.+?<td.+?>&nbsp;(.+?)</td>.+?<td.+?>&nbsp;(.+?)</td>.+?<td.+?>&nbsp;(.+?)</td>}

		while {1} {
			set idx 	[string first {<center>} $str]
			if {$idx == -1} { break }

			if { ![regexp -nocase -start $idx $rxs1 $str -> city] } { break }

#			puts $city

			set  weather [list]
			for { set i 0 } { $i < 8 } {incr i} {
				incr 	idx
				set 	idx 	[string first {<center>} $str $idx]
				if { $idx == -1 } { break }

				set weather [concat $weather [lrange [regexp -inline -nocase -start $idx $rxs2 $str] 1 end]]
				set weather [string map {{} {} {} {} {} {}} $weather]
			}

			set fsuccess 1
			break
		}
		
		if { $fsuccess } {

			set nclouds [list {n/a} {} {} {} {} {   } \
								  {  } {   } {  } {}]

			set ostr ""


			set k 0
			set i 0

			set srng 0
			set erng 4

			if { $handle eq "-" } {
				set srng 4
				set erng 8				
			}

			foreach { date clouds temp pressure wind humidity } $weather {
				if { $k >= $srng } {
					set date [string map {{<b>} "" {</b>} ""} $date]
					set temp [string map {{&deg;} ""} $temp]
					append ostr "\00306$date,\00312 $temp\00302, \00312$pressure\00302, \00312$wind\00302, \00312$humidity\00302, \00312[lindex $nclouds $clouds]"
					if { [incr i] == 2 } {
						lput putserv "\00305$city, $ostr \00314 gismeteo.ru" $prefix
						set i 0
						set ostr ""
					}
					if { $i == 1 } {
						append ostr " \002\00304\002 "
					}
				}
				if { [incr k] == $erng } { break }
			}

		} else {
			lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]
		}
		
		return
	}

	proc dcc:widpudate { handle idx str } {
		variable updinprogress
		variable unamespace
		variable updatetimeout

		if { $updinprogress } {
			lput putlog "Cities indexies update already in progress..." "[namespace current] "
			return
		}
		
		if { [catch { ::http::geturl "http://gen.gismeteo.ru/frcdb/cityinfr.txt" \
										-command "[namespace current]::dcc:widpupdate_done" \
										-timeout $updatetimeout \
										-blocksize 32768 \
										-binary true } errid]} {
			lput putlog "Something goes worng, while trying to update cities indexies. ($errid)" "[namespace current] "
		}

		lput putlog "Cities indexies updating started..." "[namespace current] "
		set updinprogress 1
		return
	}

	proc dcc:widpupdate_done { token } {
		upvar #0 $token state

		variable updinprogress
		variable unamespace
		variable cityid
		variable cidbasename

		set errid [::http::status $token]

		if { $errid eq "ok" } {
			set str "[encoding convertfrom cp866 $state(body)]"
			lput putlog "Cities indixies downloaded, paaaaarsing..." "[namespace current] "
if { [catch {
      array unset cityid
			set sidx 0

			while (1) {
				set eidx [string first "\x0D" $str $sidx]
				if { $eidx == -1 } { break }
				if { [expr { $eidx - $sidx }] > 20 } {
					set line [string range $str $sidx $eidx]
					set id 	 [string range $line 5 9]
					set city [string tolower [string range $line 21 end-1]]

					set cityid($city) $id

				}			

				set sidx [incr eidx 2]
			}

} err] } {
			lput putlog "Cities index parsing failes. Error: $err" $unamespace
}
			lput putlog "Cities indexies update done. Cities in base: [llength [array names cityid]]." "[namespace current] "

			lput putlog "Trying save cities index to file: '$cidbasename'" "[namespace current] "

			if { [catch {
				set  hfile [open $cidbasename w]
				puts $hfile [array get cityid]
				close $hfile
				lput putlog "Database saved to file: '$cidbasename'" "[namespace current] "

			} err] } {
				lput putlog "Database saving failed. Error: $err" $unamespace
			}

		} else {
			lput putlog "Cities indexies update failed. Error: $errid" "[namespace current] "
		}

		set updinprogress 0
		::http::cleanup $token	
		return
	}

	proc loaddbcid { } {
		variable unamespace
		variable cityid
		variable cidbasename

		if { [catch {
			lput putlog "Trying loading cities index from file: '$cidbasename'" "[namespace current] "

			if { [file exists $cidbasename] } {
				set hfile [open $cidbasename r]
				set str [read $hfile]
				close $hfile

				array unset cityid
				array set cityid $str
				
				lput putlog "Cities indexies loaded from '$cidbasename'. Cities in base: [llength [array names cityid]]" "[namespace current] "

			} else {
				lput putlog "File '$cidbasename' does not exists. Please update." "[namespace current] "
			}
		} err]} { 
			lput putlog "Loading indexies from '$cidbasename' failed. Error: $err" "[namespace current] "
			array unset cityid			
		}
	}
# ---------------------------------------------------------------------------
#
# ---------------------------------------------------------------------------

	proc lput { cmd str { prefix {} } {maxchunk 400} } {
		set plen 	[string length $prefix]
		set	slen    [string length $str]
		set sidx	0

		while { $slen != 0 } {
			set nsl [expr { [expr { $slen + $plen }] < $maxchunk ? $slen : [ expr { $maxchunk - $plen } ] } ]

			$cmd $prefix[string range $str $sidx [expr { $sidx + $nsl - 1} ] ]
		
			incr slen -$nsl
			incr sidx  $nsl
		}
		
		return
	}

	proc queue_isfreefor { { id {} } } {

		variable reqqueue
		variable maxreqperuser
		variable maxrequests
		variable laststamp
		variable pause

		variable err_queue_full	
		variable err_queue_id
		variable err_queue_time 

		if { [info exists laststamp(stamp,$id)] } {
			set timewait [expr { $laststamp(stamp,$id) + $pause - [unixtime]}]

			if { $timewait > 0 } {
				return [subst -nocommands $err_queue_time]
			}			
		}

		if { [llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser } {
			return $err_queue_id
		}

		if { [llength [array names reqqueue]] >= $maxrequests } { 
			return $err_queue_full
		}
		
		return
	}

	proc queue_add { newurl id parser extra {redir 0} } {
		variable reqqueue
		variable proxy
		variable timeout
		variable laststamp

		::http::config -proxyfilter "[namespace current]::queue_proxy"
		
		if { ! [catch {
			set token [::http::geturl $newurl -command "[namespace current]::queue_done" -binary true -timeout $timeout]
			} errid] } {
					
			set reqqueue($token,$id) [list $parser $extra $redir]		
#			lput putlog "$token,$id"
			set laststamp(stamp,$id) [unixtime]

		} else {
			return false
		}

		return true
	}

	proc queue_proxy { url } {
		variable proxy
		if { $proxy ne {} } { return [split $proxy {:}] }		
		return [list]
	}
	
	proc queue_done { token } {
		upvar #0 $token state
		variable reqqueue
		variable maxredir

#		lput putlog "$token"
		
		set errid  		[::http::status $token]
		set errstr 		[::http::error  $token]
		
		set	id  	[array  names reqqueue "$token,*"]
		foreach { parser extra redir } $reqqueue($id) { break }
		regsub -- "^$token," $id {} id
	
		while (1) {
			if { $errid == "ok" && [::http::ncode $token] == 302 } {
				if { $redir < $maxredir } {			
					array set meta $state(meta)
					if { [info exists meta(Location)] } {
						variable fetchurl
						queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]
						break
					}
				} else {
					set errid   "error"
					set errstr  "Maximum redirects reached"
				}
			} 
			
			if { [catch { $parser {errid} {errstr} {state(body)} {extra} } errid ] } {
				lput putlog $errid "[namespace current] "
			}

			break
		}
			
		array unset reqqueue "$token,*"
		::http::cleanup $token

		return
	}

	proc queue_clear_stamps {} {

		variable laststamp
		variable timeout

		set curr [expr { [unixtime] - 2 * $timeout / 1000 }];
#		putlog "stamps: $curr"		

		foreach { id } [array names laststamp] {
			if { $laststamp($id) < $curr } {
				array unset laststamp $id;
			}
		}		

#		putlog "stamps: [array get laststamp]"

		timer 10 "[info level 0]"
	}

	proc cmdaliases { { action {bind} } } {
		foreach { bindtype } {pub msg dcc} {
			foreach { bindproc } [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix"
				variable "${bindtype}flag"			
				foreach { alias } [set $bindproc] {
#					putlog "$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc"
					catch { $action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc }
				}				
			}
		}
		
		return
	}
	
	[namespace current]::queue_clear_stamps
	cmdaliases
	loaddbcid
	putlog "[namespace current] v$version \[$date\] by $author loaded."
}

